function [f1opt,f2opt,f1,f2,gammabest,iter,minE,drct_srfc,R] = ESD_comp_surf_3d(iten,both_drct,b1,b2,r,t,MN,M,N)

% both_drct = for dertermining whether one of the surfaces is to be
% considered in the reversed direction (0 if no, 1 if yes)
%
% drct_srfc = surface 1 direction for optimality (1 [as given] -1 [counter])
% R = optimal rotation
%
drct_srfc = 1;

%computation of areas of surfaces
area1 = 0;
itot = 0;
for j=1:N-1
    for i=1:M-1
      i0 = itot+i;
      i1 = i0+M;
      i2 = i1+1;
      x1 = b1(1,i1)-b1(1,i0);
      y1 = b1(2,i1)-b1(2,i0);
      z1 = b1(3,i1)-b1(3,i0);
      x2 = b1(1,i2)-b1(1,i0);
      y2 = b1(2,i2)-b1(2,i0);
      z2 = b1(3,i2)-b1(3,i0);
      areap = sqrt((y1*z2-y2*z1)^2 + (x1*z2-x2*z1)^2 +(x1*y2-x2*y1)^2);
      area1 = area1+areap;
      i1 = i0+1;
      x1 = b1(1,i1)-b1(1,i0);
      y1 = b1(2,i1)-b1(2,i0);
      z1 = b1(3,i1)-b1(3,i0);
      areap = sqrt((y1*z2-y2*z1)^2 + (x1*z2-x2*z1)^2 +(x1*y2-x2*y1)^2);
      area1 = area1+areap;
    end
    itot = itot+M;
end
area1 = area1/2;
%area1
area1 = sqrt(area1);
%area1
f1=b1/area1;
%
area2 = 0;
itot = 0;
for j=1:N-1
    for i=1:M-1
      i0 = itot+i;
      i1 = i0+M;
      i2 = i1+1;
      x1 = b2(1,i1)-b2(1,i0);
      y1 = b2(2,i1)-b2(2,i0);
      z1 = b2(3,i1)-b2(3,i0);
      x2 = b2(1,i2)-b2(1,i0);
      y2 = b2(2,i2)-b2(2,i0);
      z2 = b2(3,i2)-b2(3,i0);
      areap = sqrt((y1*z2-y2*z1)^2 + (x1*z2-x2*z1)^2 +(x1*y2-x2*y1)^2);
      area2 = area2+areap;
      i1 = i0+1;
      x1 = b2(1,i1)-b2(1,i0);
      y1 = b2(2,i1)-b2(2,i0);
      z1 = b2(3,i1)-b2(3,i0);
      areap = sqrt((y1*z2-y2*z1)^2 + (x1*z2-x2*z1)^2 +(x1*y2-x2*y1)^2);
      area2 = area2+areap;
    end
    itot = itot+M;
end
area2 = area2/2;
%area2
area2 = sqrt(area2);
%area2
f2=b2/area2;
%
%computation of areas of surfaces this time for verifying areas now equal 1.0
areaver = 0;
if (areaver)
%
area1 = 0;
itot = 0;
for j=1:N-1
    for i=1:M-1
      i0 = itot+i;
      i1 = i0+M;
      i2 = i1+1;
      x1 = f1(1,i1)-f1(1,i0);
      y1 = f1(2,i1)-f1(2,i0);
      z1 = f1(3,i1)-f1(3,i0);
      x2 = f1(1,i2)-f1(1,i0);
      y2 = f1(2,i2)-f1(2,i0);
      z2 = f1(3,i2)-f1(3,i0);
      areap = sqrt((y1*z2-y2*z1)^2 + (x1*z2-x2*z1)^2 +(x1*y2-x2*y1)^2);
      area1 = area1+areap;
      i1 = i0+1;
      x1 = f1(1,i1)-f1(1,i0);
      y1 = f1(2,i1)-f1(2,i0);
      z1 = f1(3,i1)-f1(3,i0);
      areap = sqrt((y1*z2-y2*z1)^2 + (x1*z2-x2*z1)^2 +(x1*y2-x2*y1)^2);
      area1 = area1+areap;
    end
    itot = itot+M;
end
area1 = area1/2;
area1
%
area2 = 0;
itot = 0;
for j=1:N-1
    for i=1:M-1
      i0 = itot+i;
      i1 = i0+M;
      i2 = i1+1;
      x1 = f2(1,i1)-f2(1,i0);
      y1 = f2(2,i1)-f2(2,i0);
      z1 = f2(3,i1)-f2(3,i0);
      x2 = f2(1,i2)-f2(1,i0);
      y2 = f2(2,i2)-f2(2,i0);
      z2 = f2(3,i2)-f2(3,i0);
      areap = sqrt((y1*z2-y2*z1)^2 + (x1*z2-x2*z1)^2 +(x1*y2-x2*y1)^2);
      area2 = area2+areap;
      i1 = i0+1;
      x1 = f2(1,i1)-f2(1,i0);
      y1 = f2(2,i1)-f2(2,i0);
      z1 = f2(3,i1)-f2(3,i0);
      areap = sqrt((y1*z2-y2*z1)^2 + (x1*z2-x2*z1)^2 +(x1*y2-x2*y1)^2);
      area2 = area2+areap;
    end
    itot = itot+M;
end
area2 = area2/2;
area2
%
end

fx = f2(1,1) - f1(1,1);
fy = f2(2,1) - f1(2,1);
fz = f2(3,1) - f1(3,1);
f1(1,1:MN) = f1(1,1:MN) + fx;
f1(2,1:MN) = f1(2,1:MN) + fy;
f1(3,1:MN) = f1(3,1:MN) + fz;

[f1opt,f2opt,gammabest,iter,minE,R] = ESD_core_surf_3d(iten,f1,f2,r,t,MN,M,N);

fprintf('\n *************************************************** \n');
if(both_drct)

   i2 = 0;
   l1 = MN+1;
   for i=1:N
      i1 = i2+1;
      i2 = i2+M;
      l2 = l1-1;
      l1 = l1-M;
      f1c(:,l1:l2) = f1(:,i1:i2);
   end
   fx = f2(1,1) - f1c(1,1);
   fy = f2(2,1) - f1c(2,1);
   fz = f2(3,1) - f1c(3,1);
   f1c(1,1:MN) = f1c(1,1:MN) + fx;
   f1c(2,1:MN) = f1c(2,1:MN) + fy;
   f1c(3,1:MN) = f1c(3,1:MN) + fz;

   [f1optc,f2optc,gammacest,itec,minc,Rc] = ESD_core_surf_3d(iten,f1c,f2,r,t,MN,M,N);

   tolr = 0.0001;

   mincE = abs(minc-minE);
   if(mincE < tolr)
      vc = f1optc - f2optc;
      ve = f1opt - f2opt;
      dc = norm(vc);
      de = norm(ve);
dc
de
      if(dc < de)
         drct_srfc = -1;
         f1 = f1c;
         f1opt = f1optc;
         f2opt = f2optc;
         gammabest = gammacest;
         iter = itec;
         minE = minc;
         R = Rc;
      end
   elseif minc < minE
      drct_srfc = -1;
      f1 = f1c;
      f1opt = f1optc;
      f2opt = f2optc;
      gammabest = gammacest;
      iter = itec;
      minE = minc;
      R = Rc;
   end

end

%fprintf('\n f1(1,1), f1(2,1), f1(3,1) = %5.1f %5.1f %5.1f \n', f1(1,1), f1(2,1), f1(3,1));
%fprintf('\n f1(1,n), f1(2,n), f1(3,n) = %5.1f %5.1f %5.1f \n', f1(1,n), f1(2,n), f1(3,n));
%pause

