function [R,mxtrc] = optml_rt_rotation(q1,q2,hr,ht,M,N)

A = zeros(3,3);
itot = 0;
for j = 1:N
   i1 = itot+1;
   i2 = itot+M;
   q1r(:,1:M) = q1(:,i1:i2);
   q2r(:,1:M) = q2(:,i1:i2);
   AT = hr.*q1r*q2r';
   A = A + ht(j)*AT;
   itot = i2;
end
%A
[U,S,V] = svd(A);

detuv = det(U*V);
%fprintf('\n determinant of U*V = %5.1f \n', detuv);
%if det(A) > 0
if detuv > 0
    S = eye(3);
else
    S = eye(3);
    S(:,end) = -S(:,end);
end
R = U*S*V';
mxtrc = trace(R*A');

