function q = surface_to_q(f,hr,ht,MN,M,N)

% compute q function for f
%fx=zeros(3,MN);
itot = 0;
for j = 1:N
    i1 = itot+1;
    i2 = i1+1;
    fx(:,i1) = (f(:,i2)-f(:,i1))/hr(1);

    i2 = itot+M;
    i1 = i2-1;
    fx(:,i2) = (f(:,i2)-f(:,i1))/hr(M);

    for i = 2:M-1
        i1 = itot+i-1;
        i0 = i1+1;
        i2 = i1+2;
        fx(:,i0) = (f(:,i2)-f(:,i1))/hr(i);
    end

    itot = itot+M;
end

%fy=zeros(3,MN);
MNM = MN-M;
for i = 1:M
    i1 = i;
    i2 = i+M;
    fy(:,i1) = (f(:,i2)-f(:,i1))/ht(1);

    i2 = MNM+i;
    i1 = i2-M;
    fy(:,i2) = (f(:,i2)-f(:,i1))/ht(N);
end
itot = 0;
for j = 2:N-1

    for i = 1:M
        i1 = itot+i;
        i0 = i1+M;
        i2 = i0+M;
        fy(:,i0) = (f(:,i2)-f(:,i1))/ht(j);
    end

    itot = itot+M;
end

%q=zeros(3,MN);

for k = 1:MN
   q(:,k) = cross(fx(:,k),fy(:,k));
end
%q

%qsn=zeros(1,MN);

tol =0.0001;

for k = 1:MN
   qsn(k)=sqrt(norm(q(:,k)));
   if qsn(k) > tol
      q(:,k) = q(:,k)/qsn(k);
   else
      q(1,k) = 0;
      q(2,k) = 0;
      q(3,k) = 0;
   end
end
%qsn
%q
%
%size(q)
%
