function [f2opt,f1opt,gamb,iter,minE,Ropt] = ESD_core_surf_3d(iten,f2,f1,r,t,MN,M,N)

%fprintf('\n f1(1,1), f1(2,1), f1(3,1) = %5.1f %5.1f %5.1f \n', f1(1,1), f1(2,1), f1(3,1));
%fprintf('\n f1(1,n), f1(2,n), f1(3,n) = %5.1f %5.1f %5.1f \n', f1(1,n), f1(2,n), f1(3,n));
%pause
%
% compute rotation weights and other weights for computing q functions
%
[hr,ht,dhr,dht] = rt_rotation_wghts(f1,f2,r,t,MN,M,N);
%hr
%ht
%dhr
%dht
%
% compute q functions for f1 and f2
%
q1 = surface_to_q(f1,dhr,dht,MN,M,N);
q2 = surface_to_q(f2,dhr,dht,MN,M,N);
%q1
%q2
%
layrs = 12;
lstrp = 100;
mleng = 0.0007d0;
iopt = 3;
imuth = 0;
minE = 200000;
Ep = 200000;
iter = 1;
tol = 0.0001;
Ec = 100000;
%
q1n = q1;
%tic;
%
%f1j=zeros(3,M);
%q1j=zeros(3,M);
%q2j=zeros(3,M);
%
while (iter <= iten && abs(Ec-Ep) > tol)
%fprintf('\n ************************ Ec, Ep = %9.4f %9.4f \n',Ec,Ep);
   iter = iter + 1;
   Ep = Ec;
%tic
%
   R = optml_rt_rotation(q1n,q2,hr,ht,M,N);
R
%
%toc
%tic
   q2n = R*q2;
%t
   i2 = 0;
   for j = 1:N
      i1 = i2+1;
      i2 = i2+M;
      f1j(:,1:M) = f1(:,i1:i2);
      q1j(:,1:M) = q1(:,i1:i2);
      q2j(:,1:M) = q2n(:,i1:i2);
%
      if(imuth)
         [new_gamma,pfly,pflp,Energy,laymx,lbnd,hbnd] = DP_MEX_WNDSTRP_ALLDIM(q2j,q1j,r,r,layrs,lstrp,mleng,iopt);
      else
         [new_gamma,pfly,pflp,Energy,laymx]= DP_MEX_WNDSTRP_ALLDIM(q2j,q1j,r,r,layrs,lstrp,mleng,iopt);
      end
Energy
%
      f1jn = spline(r,f1j,new_gamma);
      f1n(:,i1:i2) = f1jn(:,1:M);
      gamn(i1:i2) = new_gamma(1:M);
%
   end
%
   q1n = surface_to_q(f1n,dhr,dht,MN,M,N);
%
   Ec =0;
   i2 = 0;
   for j = 1:N
      i1 = i2+1;
      i2 = i2+M;
      q1j(:,1:M) = q1n(:,i1:i2);
      q2j(:,1:M) = q2n(:,i1:i2);
      Ecj = 0;
      for i = 1:M
         qjdif(:) = q1j(:,i)-q2j(:,i);
         Ecj = Ecj + hr(i)*dot(qjdif,qjdif);
      end
      Ec = Ec + ht(j)*Ecj;
   end
%Ec
%Ep
   if Ec < minE
      f1opt = f1n;
      gamb = gamn;
      minE = Ec;
      Ropt = R;
   end
%toc
end
iter = iter-1;
f2opt = Ropt*f2;
%gamb
iter
Ropt
minE

%  fprintf('\n Number of while loop iterations and maximum number allowed = %2.0f %2.0f \n',iter,iten);

%fprintf('\n \n');

%timing_gamma = toc
%
