c23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
c
c     Program helicoid.f
c
c     to generate 2 helicoid surfaces
c
*MAIN
c
      program main
c
      integer mmax, nmax, mnmax
      parameter (mmax = 110, nmax = 110, mnmax = 12100)
      double precision r(mmax), t(nmax), r2(mmax), t2(nmax)
      double precision x(mnmax), y(mnmax), z(mnmax)
      double precision x1(mnmax), y1(mnmax), z1(mnmax)
      double precision wpi, wsp, wzp, win, wtp, won, wk, wi
      integer i, j, mlen, nlen, icur
c
      open (11, file = 'x_domain.txt')
      open (12, file = 'y_domain.txt')
      open (13, file = 'surface1.txt')
      open (14, file = 'surface2.txt')
c
      open (21, file = 'edge1b.txt')     
      open (22, file = 'edge1t.txt')     
      open (23, file = 'edge1l.txt')     
      open (24, file = 'edge1r.txt')     
c
      open (31, file = 'edge2b.txt')     
      open (32, file = 'edge2t.txt')     
      open (33, file = 'edge2l.txt')     
      open (34, file = 'edge2r.txt')     
c
      wpi = 3.14159265d0
c
      mlen = 101
      nlen = 101
      wzp = 1.0d0/dble(mlen-1)
      do 100 i = 1, mlen
         win = dble(i-1)*wzp
         r(i) = win
         t(i) = win
         write(11,*) r(i)
         write(12,*) t(i)
         r2(i) = dsqrt(dsqrt(r(i)))*r(i)
         t2(i) = dsqrt(dsqrt(t(i)))*t(i)
         t2(i) = t(i)
  100 continue
c
      wi = 4.0d0
      wk = 4.0d0
      wsp = wi*wpi
      wtp = wk*wpi
      icur = 0
      do 300 j = 1, nlen
         win = wsp*t(j)
         won = wtp*t2(j)
         do 200 i = 1, mlen
            icur = icur+1
            x(icur) = r2(i)*dcos(won)
            y(icur) = r2(i)*dsin(won)
            z(icur) = won
            write(14,*) x(icur), y(icur), z(icur)
            if(j.eq.1) write(31,*) x(icur), y(icur), z(icur)
            if(j.eq.nlen) write(32,*) x(icur), y(icur), z(icur)
            if(i.eq.1) write(33,*) x(icur), y(icur), z(icur)
            if(i.eq.mlen) write(34,*) x(icur), y(icur), z(icur)
            x1(icur) = win
            y1(icur) = r(i)*dcos(win)
            z1(icur) = r(i)*dsin(win)
            write(13,*) x1(icur), y1(icur), z1(icur)
            if(j.eq.1) write(21,*) x1(icur), y1(icur), z1(icur)
            if(j.eq.nlen) write(22,*) x1(icur), y1(icur), z1(icur)
            if(i.eq.1) write(23,*) x1(icur), y1(icur), z1(icur)
            if(i.eq.mlen) write(24,*) x1(icur), y1(icur), z1(icur)
  200     continue
  300 continue
c
      stop
      end
